#! /bin/bash
function build(){
	cd $1
	echo -e "\n\e[4mBuilding $1\e[0m"
	files=`ls | grep .cpp`
	echo -e "Compiling the Following files: \n$files"
	success=0
	if g++ -Wall -c *.cpp ../*.cpp
	then
		echo "Linking..."
		if g++ -Wall -o../../bin/$1 *.o $2
		then
			success=1
		fi		
	fi
	rm *.o
	if [[ $success == 1 ]]
	then 
		echo -e "\e[32mSucessfully built $1.\e[0m"
	else
		echo -e "\e[31mBuilding $1 failed.\e[0m"
	fi
	cd ..
	}
case $1 in
"--help")
	cat BUILDING.txt
	exit
	;;
"")
	version="dev"
	;;
*)	
	version=$1
	;;
esac

echo -e "\e[1mBuilding Version $version\e[0m"

cd src

build server "-lm"
build client "-lGL -lglut"

cd ..
builddate=`date`
echo -e "Dragonblocks Bedrock Edition\nVersion: $version\nBuild: $builddate" > NOTIFY.txt