#include <string>
#include <iostream>
#include <GL/glut.h>
#include "../map.h"
#include "../node.h"
#include "graphics.h"
#define BLOCKWIDTH 15
using namespace std;
Map *map;
void Graphics::drawMap(){
	glClear(GL_COLOR_BUFFER_BIT);
	for(int x = 0; x < 50; x++){
		for(int y  = 0; y < 50; y++){
			Graphics::drawRectangle(x*BLOCKWIDTH, y*BLOCKWIDTH, BLOCKWIDTH, BLOCKWIDTH, map->getNode(x,y)->red, map->getNode(x,y)->green, map->getNode(x,y)->blue);
			}
		}
	glFlush();
	}
void Graphics::reshape(int width, int height){
	glViewport(0, 0, width, height);       /* Establish viewing area to cover entire window. */
	glMatrixMode(GL_PROJECTION);  /* Start modifying the projection matrix. */
	glLoadIdentity();             /* Reset project matrix. */
	glOrtho(0, width, 0, height, -1, 1);   /* Map abstract coords directly to window coords. */
	glScalef(1, -1, 1);           /* Invert Y axis so increasing Y goes down. */
	glTranslatef(0, -height, 0);       /* Shift origin up to upper-left corner. */
	}
Graphics::Graphics(int *argc, char **argv, Map *m){
	map = m;
	glutInit(argc, argv);
	glutInitWindowSize(50*BLOCKWIDTH, 50*BLOCKWIDTH);
	glutCreateWindow("Dragonblocks");
	glutDisplayFunc(Graphics::drawMap);
	glutReshapeFunc(Graphics::reshape);
	glutMainLoop();
	}
void Graphics::drawRectangle(int x, int y, int width, int height, float red, float green, float blue){
	glBegin(GL_POLYGON);
	glColor3f(red, green, blue);
	glVertex2i(x, y);
	glColor3f(red, green, blue);
	glVertex2i(x+width, y);
	glColor3f(red, green, blue);
	glVertex2i(x+width, y+height);
	glColor3f(red, green, blue);
	glVertex2i(x, y+height);
	glEnd();
	}
